.\"	$NetBSD: cpuctl.8,v 1.5 2008/06/22 13:53:59 ad Exp $
.\"
.\" Copyright (c) 2007, 2008 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Andrew Doran.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd June 22, 2008
.Dt CPUCTL 8
.Os
.Sh NAME
.Nm cpuctl
.Nd program to control CPUs
.Sh SYNOPSIS
.Nm cpuctl
.Ar command
.Op Ar arguments
.Sh DESCRIPTION
The
.Nm
command can be used to control and inspect the state of CPUs in the system.
.Pp
The first argument,
.Ar command ,
specifies the action to take.
Valid commands are:
.Bl -tag -width XofflineXcpunoX
.It identify Ar cpu
Output information on the specified CPU's features and capabilities.
Not available on all architectures.
.It list
For each CPU in the system, display the current state and time of the last
state change.
.It offline Ar cpuno
Set the specified CPU off line.
.Pp
Unbound LWPs (lightweight processes) will not be executed on the CPU
while it is off line.
Bound LWPs will continue to be executed on the CPU, and device interrupts
routed to the CPU will continue to be handled.
A future release of the system may allow device interrupts to be re-routed
away from individual CPUs.
.Pp
At least one CPU in the system must remain on line.
.It online Ar cpuno
Set the specified CPU on line, making it available to run unbound LWPs.
.El
.Sh FILES
.Bl -tag -width /dev/cpuctl -compact
.It Pa /dev/cpuctl
control device
.El
.Sh SEE ALSO
.Xr psrset 8 ,
.Xr schedctl 8
.Sh HISTORY
The
.Nm
command first appeared in
.Nx 5.0 .
